<!doctype html>

<html>
<head>
  <link rel="shortcut icon" href="static/images/favicon.ico" type="image/x-icon">
  <title>message.js (Closure Library API Documentation - JavaScript)</title>
  <link rel="stylesheet" href="static/css/base.css">
  <link rel="stylesheet" href="static/css/doc.css">
  <link rel="stylesheet" href="static/css/sidetree.css">
  <link rel="stylesheet" href="static/css/prettify.css">

  <script>
     var _staticFilePath = "static/";
     var _typeTreeName = "goog";
     var _fileTreeName = "Source";
  </script>

  <script src="static/js/doc.js">
  </script>


  <meta charset="utf8">
</head>

<body onload="grokdoc.onLoad();">

<div id="header">
  <div class="g-section g-tpl-50-50 g-split">
    <div class="g-unit g-first">
      <a id="logo" href="index.html">Closure Library API Documentation</a>
    </div>

    <div class="g-unit">
      <div class="g-c">
        <strong>Go to class or file:</strong>
        <input type="text" id="ac">
      </div>
    </div>
  </div>
</div>

<div class="clear"></div>

<h2><a href="local_closure_goog_proto2_message.js.html">message.js</a></h2>

<pre class="prettyprint lang-js">
<a name="line1"></a>// Copyright 2008 The Closure Library Authors. All Rights Reserved.
<a name="line2"></a>//
<a name="line3"></a>// Licensed under the Apache License, Version 2.0 (the &quot;License&quot;);
<a name="line4"></a>// you may not use this file except in compliance with the License.
<a name="line5"></a>// You may obtain a copy of the License at
<a name="line6"></a>//
<a name="line7"></a>//      http://www.apache.org/licenses/LICENSE-2.0
<a name="line8"></a>//
<a name="line9"></a>// Unless required by applicable law or agreed to in writing, software
<a name="line10"></a>// distributed under the License is distributed on an &quot;AS-IS&quot; BASIS,
<a name="line11"></a>// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
<a name="line12"></a>// See the License for the specific language governing permissions and
<a name="line13"></a>// limitations under the License.
<a name="line14"></a>
<a name="line15"></a>/**
<a name="line16"></a> * @fileoverview Protocol Buffer Message base class.
<a name="line17"></a> */
<a name="line18"></a>
<a name="line19"></a>goog.provide(&#39;goog.proto2.Message&#39;);
<a name="line20"></a>
<a name="line21"></a>goog.require(&#39;goog.asserts&#39;);
<a name="line22"></a>goog.require(&#39;goog.proto2.Descriptor&#39;);
<a name="line23"></a>goog.require(&#39;goog.proto2.FieldDescriptor&#39;);
<a name="line24"></a>
<a name="line25"></a>
<a name="line26"></a>
<a name="line27"></a>/**
<a name="line28"></a> * Abstract base class for all Protocol Buffer 2 messages. It will be
<a name="line29"></a> * subclassed in the code generated by the Protocol Compiler. Any other
<a name="line30"></a> * subclasses are prohibited.
<a name="line31"></a> * @constructor
<a name="line32"></a> */
<a name="line33"></a>goog.proto2.Message = function() {
<a name="line34"></a>  /**
<a name="line35"></a>   * Stores the field values in this message. Keyed by the tag of the fields.
<a name="line36"></a>   * @type {*}
<a name="line37"></a>   * @private
<a name="line38"></a>   */
<a name="line39"></a>  this.values_ = {};
<a name="line40"></a>
<a name="line41"></a>  /**
<a name="line42"></a>   * Stores the field information (i.e. metadata) about this message.
<a name="line43"></a>   * @type {Object.&lt;number, !goog.proto2.FieldDescriptor&gt;}
<a name="line44"></a>   * @private
<a name="line45"></a>   */
<a name="line46"></a>  this.fields_ = this.getDescriptor().getFieldsMap();
<a name="line47"></a>
<a name="line48"></a>  /**
<a name="line49"></a>   * The lazy deserializer for this message instance, if any.
<a name="line50"></a>   * @type {goog.proto2.LazyDeserializer}
<a name="line51"></a>   * @private
<a name="line52"></a>   */
<a name="line53"></a>  this.lazyDeserializer_ = null;
<a name="line54"></a>
<a name="line55"></a>  /**
<a name="line56"></a>   * A map of those fields deserialized, from tag number to their deserialized
<a name="line57"></a>   * value.
<a name="line58"></a>   * @type {Object}
<a name="line59"></a>   * @private
<a name="line60"></a>   */
<a name="line61"></a>  this.deserializedFields_ = null;
<a name="line62"></a>};
<a name="line63"></a>
<a name="line64"></a>
<a name="line65"></a>/**
<a name="line66"></a> * An enumeration defining the possible field types.
<a name="line67"></a> * Should be a mirror of that defined in descriptor.h.
<a name="line68"></a> *
<a name="line69"></a> * TODO(user): Remove this alias.  The code generator generates code that
<a name="line70"></a> * references this enum, so it needs to exist until the code generator is
<a name="line71"></a> * changed.  The enum was moved to from Message to FieldDescriptor to avoid a
<a name="line72"></a> * dependency cycle.
<a name="line73"></a> *
<a name="line74"></a> * Use goog.proto2.FieldDescriptor.FieldType instead.
<a name="line75"></a> *
<a name="line76"></a> * @enum {number}
<a name="line77"></a> */
<a name="line78"></a>goog.proto2.Message.FieldType = {
<a name="line79"></a>  DOUBLE: 1,
<a name="line80"></a>  FLOAT: 2,
<a name="line81"></a>  INT64: 3,
<a name="line82"></a>  UINT64: 4,
<a name="line83"></a>  INT32: 5,
<a name="line84"></a>  FIXED64: 6,
<a name="line85"></a>  FIXED32: 7,
<a name="line86"></a>  BOOL: 8,
<a name="line87"></a>  STRING: 9,
<a name="line88"></a>  GROUP: 10,
<a name="line89"></a>  MESSAGE: 11,
<a name="line90"></a>  BYTES: 12,
<a name="line91"></a>  UINT32: 13,
<a name="line92"></a>  ENUM: 14,
<a name="line93"></a>  SFIXED32: 15,
<a name="line94"></a>  SFIXED64: 16,
<a name="line95"></a>  SINT32: 17,
<a name="line96"></a>  SINT64: 18
<a name="line97"></a>};
<a name="line98"></a>
<a name="line99"></a>
<a name="line100"></a>/**
<a name="line101"></a> * All instances of goog.proto2.Message should have a static descriptorObj_
<a name="line102"></a> * property. This is a JSON representation of a Descriptor. The real Descriptor
<a name="line103"></a> * will be deserialized lazily in the getDescriptor() method.
<a name="line104"></a> *
<a name="line105"></a> * This declaration is just here for documentation purposes.
<a name="line106"></a> * goog.proto2.Message does not have its own descriptor.
<a name="line107"></a> *
<a name="line108"></a> * @type {undefined}
<a name="line109"></a> * @private
<a name="line110"></a> */
<a name="line111"></a>goog.proto2.Message.descriptorObj_;
<a name="line112"></a>
<a name="line113"></a>
<a name="line114"></a>/**
<a name="line115"></a> * All instances of goog.proto2.Message should have a static descriptor_
<a name="line116"></a> * property. The Descriptor will be deserialized lazily in the getDescriptor()
<a name="line117"></a> * method.
<a name="line118"></a> *
<a name="line119"></a> * This declaration is just here for documentation purposes.
<a name="line120"></a> * goog.proto2.Message does not have its own descriptor.
<a name="line121"></a> *
<a name="line122"></a> * @type {undefined}
<a name="line123"></a> * @private
<a name="line124"></a> */
<a name="line125"></a>goog.proto2.Message.descriptor_;
<a name="line126"></a>
<a name="line127"></a>
<a name="line128"></a>/**
<a name="line129"></a> * Initializes the message with a lazy deserializer and its associated data.
<a name="line130"></a> * This method should be called by internal methods ONLY.
<a name="line131"></a> *
<a name="line132"></a> * @param {goog.proto2.LazyDeserializer} deserializer The lazy deserializer to
<a name="line133"></a> *   use to decode the data on the fly.
<a name="line134"></a> *
<a name="line135"></a> * @param {*} data The data to decode/deserialize.
<a name="line136"></a> */
<a name="line137"></a>goog.proto2.Message.prototype.initializeForLazyDeserializer = function(
<a name="line138"></a>    deserializer, data) {
<a name="line139"></a>
<a name="line140"></a>  this.lazyDeserializer_ = deserializer;
<a name="line141"></a>  this.values_ = data;
<a name="line142"></a>  this.deserializedFields_ = {};
<a name="line143"></a>};
<a name="line144"></a>
<a name="line145"></a>
<a name="line146"></a>/**
<a name="line147"></a> * Sets the value of an unknown field, by tag.
<a name="line148"></a> *
<a name="line149"></a> * @param {number} tag The tag of an unknown field (must be &gt;= 1).
<a name="line150"></a> * @param {*} value The value for that unknown field.
<a name="line151"></a> */
<a name="line152"></a>goog.proto2.Message.prototype.setUnknown = function(tag, value) {
<a name="line153"></a>  goog.asserts.assert(!this.fields_[tag],
<a name="line154"></a>      &#39;Field is not unknown in this message&#39;);
<a name="line155"></a>  goog.asserts.assert(tag &gt;= 1, &#39;Tag is not valid&#39;);
<a name="line156"></a>  goog.asserts.assert(value !== null, &#39;Value cannot be null&#39;);
<a name="line157"></a>
<a name="line158"></a>  this.values_[tag] = value;
<a name="line159"></a>  if (this.deserializedFields_) {
<a name="line160"></a>    delete this.deserializedFields_[tag];
<a name="line161"></a>  }
<a name="line162"></a>};
<a name="line163"></a>
<a name="line164"></a>
<a name="line165"></a>/**
<a name="line166"></a> * Iterates over all the unknown fields in the message.
<a name="line167"></a> *
<a name="line168"></a> * @param {function(number, *)} callback A callback method
<a name="line169"></a> *     which gets invoked for each unknown field.
<a name="line170"></a> * @param {Object=} opt_scope The scope under which to execute the callback.
<a name="line171"></a> *     If not given, the current message will be used.
<a name="line172"></a> */
<a name="line173"></a>goog.proto2.Message.prototype.forEachUnknown = function(callback, opt_scope) {
<a name="line174"></a>  var scope = opt_scope || this;
<a name="line175"></a>  for (var key in this.values_) {
<a name="line176"></a>    var keyNum = Number(key);
<a name="line177"></a>    if (!this.fields_[keyNum]) {
<a name="line178"></a>      callback.call(scope, keyNum, this.values_[key]);
<a name="line179"></a>    }
<a name="line180"></a>  }
<a name="line181"></a>};
<a name="line182"></a>
<a name="line183"></a>
<a name="line184"></a>/**
<a name="line185"></a> * Returns the descriptor which describes the current message.
<a name="line186"></a> *
<a name="line187"></a> * This only works if we assume people never subclass protobufs.
<a name="line188"></a> *
<a name="line189"></a> * @return {!goog.proto2.Descriptor} The descriptor.
<a name="line190"></a> */
<a name="line191"></a>goog.proto2.Message.prototype.getDescriptor = function() {
<a name="line192"></a>  // NOTE(nicksantos): These sorts of indirect references to descriptor
<a name="line193"></a>  // through this.constructor are fragile. See the comments
<a name="line194"></a>  // in set$Metadata for more info.
<a name="line195"></a>  var Ctor = this.constructor;
<a name="line196"></a>  return Ctor.descriptor_ ||
<a name="line197"></a>      (Ctor.descriptor_ = goog.proto2.Message.createDescriptor_(
<a name="line198"></a>          Ctor, Ctor.descriptorObj_));
<a name="line199"></a>};
<a name="line200"></a>
<a name="line201"></a>
<a name="line202"></a>/**
<a name="line203"></a> * Returns whether there is a value stored at the field specified by the
<a name="line204"></a> * given field descriptor.
<a name="line205"></a> *
<a name="line206"></a> * @param {goog.proto2.FieldDescriptor} field The field for which to check
<a name="line207"></a> *     if there is a value.
<a name="line208"></a> *
<a name="line209"></a> * @return {boolean} True if a value was found.
<a name="line210"></a> */
<a name="line211"></a>goog.proto2.Message.prototype.has = function(field) {
<a name="line212"></a>  goog.asserts.assert(
<a name="line213"></a>      field.getContainingType() == this.getDescriptor(),
<a name="line214"></a>      &#39;The current message does not contain the given field&#39;);
<a name="line215"></a>
<a name="line216"></a>  return this.has$Value(field.getTag());
<a name="line217"></a>};
<a name="line218"></a>
<a name="line219"></a>
<a name="line220"></a>/**
<a name="line221"></a> * Returns the array of values found for the given repeated field.
<a name="line222"></a> *
<a name="line223"></a> * @param {goog.proto2.FieldDescriptor} field The field for which to
<a name="line224"></a> *     return the values.
<a name="line225"></a> *
<a name="line226"></a> * @return {!Array} The values found.
<a name="line227"></a> */
<a name="line228"></a>goog.proto2.Message.prototype.arrayOf = function(field) {
<a name="line229"></a>  goog.asserts.assert(
<a name="line230"></a>      field.getContainingType() == this.getDescriptor(),
<a name="line231"></a>      &#39;The current message does not contain the given field&#39;);
<a name="line232"></a>
<a name="line233"></a>  return this.array$Values(field.getTag());
<a name="line234"></a>};
<a name="line235"></a>
<a name="line236"></a>
<a name="line237"></a>/**
<a name="line238"></a> * Returns the number of values stored in the given field.
<a name="line239"></a> *
<a name="line240"></a> * @param {goog.proto2.FieldDescriptor} field The field for which to count
<a name="line241"></a> *     the number of values.
<a name="line242"></a> *
<a name="line243"></a> * @return {number} The count of the values in the given field.
<a name="line244"></a> */
<a name="line245"></a>goog.proto2.Message.prototype.countOf = function(field) {
<a name="line246"></a>  goog.asserts.assert(
<a name="line247"></a>      field.getContainingType() == this.getDescriptor(),
<a name="line248"></a>      &#39;The current message does not contain the given field&#39;);
<a name="line249"></a>
<a name="line250"></a>  return this.count$Values(field.getTag());
<a name="line251"></a>};
<a name="line252"></a>
<a name="line253"></a>
<a name="line254"></a>/**
<a name="line255"></a> * Returns the value stored at the field specified by the
<a name="line256"></a> * given field descriptor.
<a name="line257"></a> *
<a name="line258"></a> * @param {goog.proto2.FieldDescriptor} field The field for which to get the
<a name="line259"></a> *     value.
<a name="line260"></a> * @param {number=} opt_index If the field is repeated, the index to use when
<a name="line261"></a> *     looking up the value.
<a name="line262"></a> *
<a name="line263"></a> * @return {*} The value found or null if none.
<a name="line264"></a> */
<a name="line265"></a>goog.proto2.Message.prototype.get = function(field, opt_index) {
<a name="line266"></a>  goog.asserts.assert(
<a name="line267"></a>      field.getContainingType() == this.getDescriptor(),
<a name="line268"></a>      &#39;The current message does not contain the given field&#39;);
<a name="line269"></a>
<a name="line270"></a>  return this.get$Value(field.getTag(), opt_index);
<a name="line271"></a>};
<a name="line272"></a>
<a name="line273"></a>
<a name="line274"></a>/**
<a name="line275"></a> * Returns the value stored at the field specified by the
<a name="line276"></a> * given field descriptor or the default value if none exists.
<a name="line277"></a> *
<a name="line278"></a> * @param {goog.proto2.FieldDescriptor} field The field for which to get the
<a name="line279"></a> *     value.
<a name="line280"></a> * @param {number=} opt_index If the field is repeated, the index to use when
<a name="line281"></a> *     looking up the value.
<a name="line282"></a> *
<a name="line283"></a> * @return {*} The value found or the default if none.
<a name="line284"></a> */
<a name="line285"></a>goog.proto2.Message.prototype.getOrDefault = function(field, opt_index) {
<a name="line286"></a>  goog.asserts.assert(
<a name="line287"></a>      field.getContainingType() == this.getDescriptor(),
<a name="line288"></a>      &#39;The current message does not contain the given field&#39;);
<a name="line289"></a>
<a name="line290"></a>  return this.get$ValueOrDefault(field.getTag(), opt_index);
<a name="line291"></a>};
<a name="line292"></a>
<a name="line293"></a>
<a name="line294"></a>/**
<a name="line295"></a> * Stores the given value to the field specified by the
<a name="line296"></a> * given field descriptor. Note that the field must not be repeated.
<a name="line297"></a> *
<a name="line298"></a> * @param {goog.proto2.FieldDescriptor} field The field for which to set
<a name="line299"></a> *     the value.
<a name="line300"></a> * @param {*} value The new value for the field.
<a name="line301"></a> */
<a name="line302"></a>goog.proto2.Message.prototype.set = function(field, value) {
<a name="line303"></a>  goog.asserts.assert(
<a name="line304"></a>      field.getContainingType() == this.getDescriptor(),
<a name="line305"></a>      &#39;The current message does not contain the given field&#39;);
<a name="line306"></a>
<a name="line307"></a>  this.set$Value(field.getTag(), value);
<a name="line308"></a>};
<a name="line309"></a>
<a name="line310"></a>
<a name="line311"></a>/**
<a name="line312"></a> * Adds the given value to the field specified by the
<a name="line313"></a> * given field descriptor. Note that the field must be repeated.
<a name="line314"></a> *
<a name="line315"></a> * @param {goog.proto2.FieldDescriptor} field The field in which to add the
<a name="line316"></a> *     the value.
<a name="line317"></a> * @param {*} value The new value to add to the field.
<a name="line318"></a> */
<a name="line319"></a>goog.proto2.Message.prototype.add = function(field, value) {
<a name="line320"></a>  goog.asserts.assert(
<a name="line321"></a>      field.getContainingType() == this.getDescriptor(),
<a name="line322"></a>      &#39;The current message does not contain the given field&#39;);
<a name="line323"></a>
<a name="line324"></a>  this.add$Value(field.getTag(), value);
<a name="line325"></a>};
<a name="line326"></a>
<a name="line327"></a>
<a name="line328"></a>/**
<a name="line329"></a> * Clears the field specified.
<a name="line330"></a> *
<a name="line331"></a> * @param {goog.proto2.FieldDescriptor} field The field to clear.
<a name="line332"></a> */
<a name="line333"></a>goog.proto2.Message.prototype.clear = function(field) {
<a name="line334"></a>  goog.asserts.assert(
<a name="line335"></a>      field.getContainingType() == this.getDescriptor(),
<a name="line336"></a>      &#39;The current message does not contain the given field&#39;);
<a name="line337"></a>
<a name="line338"></a>  this.clear$Field(field.getTag());
<a name="line339"></a>};
<a name="line340"></a>
<a name="line341"></a>
<a name="line342"></a>/**
<a name="line343"></a> * Compares this message with another one ignoring the unknown fields.
<a name="line344"></a> * @param {*} other The other message.
<a name="line345"></a> * @return {boolean} Whether they are equal. Returns false if the {@code other}
<a name="line346"></a> *     argument is a different type of message or not a message.
<a name="line347"></a> */
<a name="line348"></a>goog.proto2.Message.prototype.equals = function(other) {
<a name="line349"></a>  if (!other || this.constructor != other.constructor) {
<a name="line350"></a>    return false;
<a name="line351"></a>  }
<a name="line352"></a>
<a name="line353"></a>  var fields = this.getDescriptor().getFields();
<a name="line354"></a>  for (var i = 0; i &lt; fields.length; i++) {
<a name="line355"></a>    var field = fields[i];
<a name="line356"></a>    var tag = field.getTag();
<a name="line357"></a>    if (this.has$Value(tag) != other.has$Value(tag)) {
<a name="line358"></a>      return false;
<a name="line359"></a>    }
<a name="line360"></a>
<a name="line361"></a>    if (this.has$Value(tag)) {
<a name="line362"></a>      var isComposite = field.isCompositeType();
<a name="line363"></a>
<a name="line364"></a>      var fieldsEqual = function(value1, value2) {
<a name="line365"></a>        return isComposite ? value1.equals(value2) : value1 == value2;
<a name="line366"></a>      };
<a name="line367"></a>
<a name="line368"></a>      var thisValue = this.getValueForTag_(tag);
<a name="line369"></a>      var otherValue = other.getValueForTag_(tag);
<a name="line370"></a>
<a name="line371"></a>      if (field.isRepeated()) {
<a name="line372"></a>        // In this case thisValue and otherValue are arrays.
<a name="line373"></a>        if (thisValue.length != otherValue.length) {
<a name="line374"></a>          return false;
<a name="line375"></a>        }
<a name="line376"></a>        for (var j = 0; j &lt; thisValue.length; j++) {
<a name="line377"></a>          if (!fieldsEqual(thisValue[j], otherValue[j])) {
<a name="line378"></a>            return false;
<a name="line379"></a>          }
<a name="line380"></a>        }
<a name="line381"></a>      } else if (!fieldsEqual(thisValue, otherValue)) {
<a name="line382"></a>        return false;
<a name="line383"></a>      }
<a name="line384"></a>    }
<a name="line385"></a>  }
<a name="line386"></a>
<a name="line387"></a>  return true;
<a name="line388"></a>};
<a name="line389"></a>
<a name="line390"></a>
<a name="line391"></a>/**
<a name="line392"></a> * Recursively copies the known fields from the given message to this message.
<a name="line393"></a> * Removes the fields which are not present in the source message.
<a name="line394"></a> * @param {!goog.proto2.Message} message The source message.
<a name="line395"></a> */
<a name="line396"></a>goog.proto2.Message.prototype.copyFrom = function(message) {
<a name="line397"></a>  goog.asserts.assert(this.constructor == message.constructor,
<a name="line398"></a>      &#39;The source message must have the same type.&#39;);
<a name="line399"></a>
<a name="line400"></a>  if (this != message) {
<a name="line401"></a>    this.values_ = {};
<a name="line402"></a>    if (this.deserializedFields_) {
<a name="line403"></a>      this.deserializedFields_ = {};
<a name="line404"></a>    }
<a name="line405"></a>    this.mergeFrom(message);
<a name="line406"></a>  }
<a name="line407"></a>};
<a name="line408"></a>
<a name="line409"></a>
<a name="line410"></a>/**
<a name="line411"></a> * Merges the given message into this message.
<a name="line412"></a> *
<a name="line413"></a> * Singular fields will be overwritten, except for embedded messages which will
<a name="line414"></a> * be merged. Repeated fields will be concatenated.
<a name="line415"></a> * @param {!goog.proto2.Message} message The source message.
<a name="line416"></a> */
<a name="line417"></a>goog.proto2.Message.prototype.mergeFrom = function(message) {
<a name="line418"></a>  goog.asserts.assert(this.constructor == message.constructor,
<a name="line419"></a>      &#39;The source message must have the same type.&#39;);
<a name="line420"></a>  var fields = this.getDescriptor().getFields();
<a name="line421"></a>
<a name="line422"></a>  for (var i = 0; i &lt; fields.length; i++) {
<a name="line423"></a>    var field = fields[i];
<a name="line424"></a>    var tag = field.getTag();
<a name="line425"></a>    if (message.has$Value(tag)) {
<a name="line426"></a>      if (this.deserializedFields_) {
<a name="line427"></a>        delete this.deserializedFields_[field.getTag()];
<a name="line428"></a>      }
<a name="line429"></a>
<a name="line430"></a>      var isComposite = field.isCompositeType();
<a name="line431"></a>      if (field.isRepeated()) {
<a name="line432"></a>        var values = message.array$Values(tag);
<a name="line433"></a>        for (var j = 0; j &lt; values.length; j++) {
<a name="line434"></a>          this.add$Value(tag, isComposite ? values[j].clone() : values[j]);
<a name="line435"></a>        }
<a name="line436"></a>      } else {
<a name="line437"></a>        var value = message.getValueForTag_(tag);
<a name="line438"></a>        if (isComposite) {
<a name="line439"></a>          var child = this.getValueForTag_(tag);
<a name="line440"></a>          if (child) {
<a name="line441"></a>            child.mergeFrom(value);
<a name="line442"></a>          } else {
<a name="line443"></a>            this.set$Value(tag, value.clone());
<a name="line444"></a>          }
<a name="line445"></a>        } else {
<a name="line446"></a>          this.set$Value(tag, value);
<a name="line447"></a>        }
<a name="line448"></a>      }
<a name="line449"></a>    }
<a name="line450"></a>  }
<a name="line451"></a>};
<a name="line452"></a>
<a name="line453"></a>
<a name="line454"></a>/**
<a name="line455"></a> * @return {!goog.proto2.Message} Recursive clone of the message only including
<a name="line456"></a> *     the known fields.
<a name="line457"></a> */
<a name="line458"></a>goog.proto2.Message.prototype.clone = function() {
<a name="line459"></a>  var clone = new this.constructor;
<a name="line460"></a>  clone.copyFrom(this);
<a name="line461"></a>  return clone;
<a name="line462"></a>};
<a name="line463"></a>
<a name="line464"></a>
<a name="line465"></a>/**
<a name="line466"></a> * Fills in the protocol buffer with default values. Any fields that are
<a name="line467"></a> * already set will not be overridden.
<a name="line468"></a> * @param {boolean} simpleFieldsToo If true, all fields will be initialized;
<a name="line469"></a> *     if false, only the nested messages and groups.
<a name="line470"></a> */
<a name="line471"></a>goog.proto2.Message.prototype.initDefaults = function(simpleFieldsToo) {
<a name="line472"></a>  var fields = this.getDescriptor().getFields();
<a name="line473"></a>  for (var i = 0; i &lt; fields.length; i++) {
<a name="line474"></a>    var field = fields[i];
<a name="line475"></a>    var tag = field.getTag();
<a name="line476"></a>    var isComposite = field.isCompositeType();
<a name="line477"></a>
<a name="line478"></a>    // Initialize missing fields.
<a name="line479"></a>    if (!this.has$Value(tag) &amp;&amp; !field.isRepeated()) {
<a name="line480"></a>      if (isComposite) {
<a name="line481"></a>        this.values_[tag] = new /** @type {Function} */ (field.getNativeType());
<a name="line482"></a>      } else if (simpleFieldsToo) {
<a name="line483"></a>        this.values_[tag] = field.getDefaultValue();
<a name="line484"></a>      }
<a name="line485"></a>    }
<a name="line486"></a>
<a name="line487"></a>    // Fill in the existing composite fields recursively.
<a name="line488"></a>    if (isComposite) {
<a name="line489"></a>      if (field.isRepeated()) {
<a name="line490"></a>        var values = this.array$Values(tag);
<a name="line491"></a>        for (var j = 0; j &lt; values.length; j++) {
<a name="line492"></a>          values[j].initDefaults(simpleFieldsToo);
<a name="line493"></a>        }
<a name="line494"></a>      } else {
<a name="line495"></a>        this.get$Value(tag).initDefaults(simpleFieldsToo);
<a name="line496"></a>      }
<a name="line497"></a>    }
<a name="line498"></a>  }
<a name="line499"></a>};
<a name="line500"></a>
<a name="line501"></a>
<a name="line502"></a>/**
<a name="line503"></a> * Returns the whether or not the field indicated by the given tag
<a name="line504"></a> * has a value.
<a name="line505"></a> *
<a name="line506"></a> * GENERATED CODE USE ONLY. Basis of the has{Field} methods.
<a name="line507"></a> *
<a name="line508"></a> * @param {number} tag The tag.
<a name="line509"></a> *
<a name="line510"></a> * @return {boolean} Whether the message has a value for the field.
<a name="line511"></a> */
<a name="line512"></a>goog.proto2.Message.prototype.has$Value = function(tag) {
<a name="line513"></a>  return this.values_[tag] != null;
<a name="line514"></a>};
<a name="line515"></a>
<a name="line516"></a>
<a name="line517"></a>/**
<a name="line518"></a> * Returns the value for the given tag number. If a lazy deserializer is
<a name="line519"></a> * instantiated, lazily deserializes the field if required before returning the
<a name="line520"></a> * value.
<a name="line521"></a> *
<a name="line522"></a> * @param {number} tag The tag number.
<a name="line523"></a> * @return {*} The corresponding value, if any.
<a name="line524"></a> * @private
<a name="line525"></a> */
<a name="line526"></a>goog.proto2.Message.prototype.getValueForTag_ = function(tag) {
<a name="line527"></a>  // Retrieve the current value, which may still be serialized.
<a name="line528"></a>  var value = this.values_[tag];
<a name="line529"></a>  if (!goog.isDefAndNotNull(value)) {
<a name="line530"></a>    return null;
<a name="line531"></a>  }
<a name="line532"></a>
<a name="line533"></a>  // If we have a lazy deserializer, then ensure that the field is
<a name="line534"></a>  // properly deserialized.
<a name="line535"></a>  if (this.lazyDeserializer_) {
<a name="line536"></a>    // If the tag is not deserialized, then we must do so now. Deserialize
<a name="line537"></a>    // the field&#39;s value via the deserializer.
<a name="line538"></a>    if (!(tag in this.deserializedFields_)) {
<a name="line539"></a>      var deserializedValue = this.lazyDeserializer_.deserializeField(
<a name="line540"></a>          this, this.fields_[tag], value);
<a name="line541"></a>      this.deserializedFields_[tag] = deserializedValue;
<a name="line542"></a>      return deserializedValue;
<a name="line543"></a>    }
<a name="line544"></a>
<a name="line545"></a>    return this.deserializedFields_[tag];
<a name="line546"></a>  }
<a name="line547"></a>
<a name="line548"></a>  // Otherwise, just return the value.
<a name="line549"></a>  return value;
<a name="line550"></a>};
<a name="line551"></a>
<a name="line552"></a>
<a name="line553"></a>/**
<a name="line554"></a> * Gets the value at the field indicated by the given tag.
<a name="line555"></a> *
<a name="line556"></a> * GENERATED CODE USE ONLY. Basis of the get{Field} methods.
<a name="line557"></a> *
<a name="line558"></a> * @param {number} tag The field&#39;s tag index.
<a name="line559"></a> * @param {number=} opt_index If the field is a repeated field, the index
<a name="line560"></a> *     at which to get the value.
<a name="line561"></a> *
<a name="line562"></a> * @return {*} The value found or null for none.
<a name="line563"></a> * @protected
<a name="line564"></a> */
<a name="line565"></a>goog.proto2.Message.prototype.get$Value = function(tag, opt_index) {
<a name="line566"></a>  var value = this.getValueForTag_(tag);
<a name="line567"></a>
<a name="line568"></a>  if (this.fields_[tag].isRepeated()) {
<a name="line569"></a>    var index = opt_index || 0;
<a name="line570"></a>    goog.asserts.assert(index &gt;= 0 &amp;&amp; index &lt; value.length,
<a name="line571"></a>        &#39;Given index is out of bounds&#39;);
<a name="line572"></a>    return value[index];
<a name="line573"></a>  }
<a name="line574"></a>
<a name="line575"></a>  return value;
<a name="line576"></a>};
<a name="line577"></a>
<a name="line578"></a>
<a name="line579"></a>/**
<a name="line580"></a> * Gets the value at the field indicated by the given tag or the default value
<a name="line581"></a> * if none.
<a name="line582"></a> *
<a name="line583"></a> * GENERATED CODE USE ONLY. Basis of the get{Field} methods.
<a name="line584"></a> *
<a name="line585"></a> * @param {number} tag The field&#39;s tag index.
<a name="line586"></a> * @param {number=} opt_index If the field is a repeated field, the index
<a name="line587"></a> *     at which to get the value.
<a name="line588"></a> *
<a name="line589"></a> * @return {*} The value found or the default value if none set.
<a name="line590"></a> * @protected
<a name="line591"></a> */
<a name="line592"></a>goog.proto2.Message.prototype.get$ValueOrDefault = function(tag, opt_index) {
<a name="line593"></a>  if (!this.has$Value(tag)) {
<a name="line594"></a>    // Return the default value.
<a name="line595"></a>    var field = this.fields_[tag];
<a name="line596"></a>    return field.getDefaultValue();
<a name="line597"></a>  }
<a name="line598"></a>
<a name="line599"></a>  return this.get$Value(tag, opt_index);
<a name="line600"></a>};
<a name="line601"></a>
<a name="line602"></a>
<a name="line603"></a>/**
<a name="line604"></a> * Gets the values at the field indicated by the given tag.
<a name="line605"></a> *
<a name="line606"></a> * GENERATED CODE USE ONLY. Basis of the {field}Array methods.
<a name="line607"></a> *
<a name="line608"></a> * @param {number} tag The field&#39;s tag index.
<a name="line609"></a> *
<a name="line610"></a> * @return {!Array} The values found. If none, returns an empty array.
<a name="line611"></a> * @protected
<a name="line612"></a> */
<a name="line613"></a>goog.proto2.Message.prototype.array$Values = function(tag) {
<a name="line614"></a>  var value = this.getValueForTag_(tag);
<a name="line615"></a>  return /** @type {Array} */ (value) || [];
<a name="line616"></a>};
<a name="line617"></a>
<a name="line618"></a>
<a name="line619"></a>/**
<a name="line620"></a> * Returns the number of values stored in the field by the given tag.
<a name="line621"></a> *
<a name="line622"></a> * GENERATED CODE USE ONLY. Basis of the {field}Count methods.
<a name="line623"></a> *
<a name="line624"></a> * @param {number} tag The tag.
<a name="line625"></a> *
<a name="line626"></a> * @return {number} The number of values.
<a name="line627"></a> * @protected
<a name="line628"></a> */
<a name="line629"></a>goog.proto2.Message.prototype.count$Values = function(tag) {
<a name="line630"></a>  var field = this.fields_[tag];
<a name="line631"></a>  if (field.isRepeated()) {
<a name="line632"></a>    return this.has$Value(tag) ? this.values_[tag].length : 0;
<a name="line633"></a>  } else {
<a name="line634"></a>    return this.has$Value(tag) ? 1 : 0;
<a name="line635"></a>  }
<a name="line636"></a>};
<a name="line637"></a>
<a name="line638"></a>
<a name="line639"></a>/**
<a name="line640"></a> * Sets the value of the *non-repeating* field indicated by the given tag.
<a name="line641"></a> *
<a name="line642"></a> * GENERATED CODE USE ONLY. Basis of the set{Field} methods.
<a name="line643"></a> *
<a name="line644"></a> * @param {number} tag The field&#39;s tag index.
<a name="line645"></a> * @param {*} value The field&#39;s value.
<a name="line646"></a> * @protected
<a name="line647"></a> */
<a name="line648"></a>goog.proto2.Message.prototype.set$Value = function(tag, value) {
<a name="line649"></a>  if (goog.asserts.ENABLE_ASSERTS) {
<a name="line650"></a>    var field = this.fields_[tag];
<a name="line651"></a>    this.checkFieldType_(field, value);
<a name="line652"></a>  }
<a name="line653"></a>
<a name="line654"></a>  this.values_[tag] = value;
<a name="line655"></a>  if (this.deserializedFields_) {
<a name="line656"></a>    this.deserializedFields_[tag] = value;
<a name="line657"></a>  }
<a name="line658"></a>};
<a name="line659"></a>
<a name="line660"></a>
<a name="line661"></a>/**
<a name="line662"></a> * Adds the value to the *repeating* field indicated by the given tag.
<a name="line663"></a> *
<a name="line664"></a> * GENERATED CODE USE ONLY. Basis of the add{Field} methods.
<a name="line665"></a> *
<a name="line666"></a> * @param {number} tag The field&#39;s tag index.
<a name="line667"></a> * @param {*} value The value to add.
<a name="line668"></a> * @protected
<a name="line669"></a> */
<a name="line670"></a>goog.proto2.Message.prototype.add$Value = function(tag, value) {
<a name="line671"></a>  if (goog.asserts.ENABLE_ASSERTS) {
<a name="line672"></a>    var field = this.fields_[tag];
<a name="line673"></a>    this.checkFieldType_(field, value);
<a name="line674"></a>  }
<a name="line675"></a>
<a name="line676"></a>  if (!this.values_[tag]) {
<a name="line677"></a>    this.values_[tag] = [];
<a name="line678"></a>  }
<a name="line679"></a>
<a name="line680"></a>  this.values_[tag].push(value);
<a name="line681"></a>  if (this.deserializedFields_) {
<a name="line682"></a>    delete this.deserializedFields_[tag];
<a name="line683"></a>  }
<a name="line684"></a>};
<a name="line685"></a>
<a name="line686"></a>
<a name="line687"></a>/**
<a name="line688"></a> * Ensures that the value being assigned to the given field
<a name="line689"></a> * is valid.
<a name="line690"></a> *
<a name="line691"></a> * @param {!goog.proto2.FieldDescriptor} field The field being assigned.
<a name="line692"></a> * @param {*} value The value being assigned.
<a name="line693"></a> * @private
<a name="line694"></a> */
<a name="line695"></a>goog.proto2.Message.prototype.checkFieldType_ = function(field, value) {
<a name="line696"></a>  if (field.getFieldType() == goog.proto2.FieldDescriptor.FieldType.ENUM) {
<a name="line697"></a>    goog.asserts.assertNumber(value);
<a name="line698"></a>  } else {
<a name="line699"></a>    goog.asserts.assert(value.constructor == field.getNativeType());
<a name="line700"></a>  }
<a name="line701"></a>};
<a name="line702"></a>
<a name="line703"></a>
<a name="line704"></a>/**
<a name="line705"></a> * Clears the field specified by tag.
<a name="line706"></a> *
<a name="line707"></a> * GENERATED CODE USE ONLY. Basis of the clear{Field} methods.
<a name="line708"></a> *
<a name="line709"></a> * @param {number} tag The tag of the field to clear.
<a name="line710"></a> * @protected
<a name="line711"></a> */
<a name="line712"></a>goog.proto2.Message.prototype.clear$Field = function(tag) {
<a name="line713"></a>  delete this.values_[tag];
<a name="line714"></a>  if (this.deserializedFields_) {
<a name="line715"></a>    delete this.deserializedFields_[tag];
<a name="line716"></a>  }
<a name="line717"></a>};
<a name="line718"></a>
<a name="line719"></a>
<a name="line720"></a>/**
<a name="line721"></a> * Creates the metadata descriptor representing the definition of this message.
<a name="line722"></a> *
<a name="line723"></a> * @param {function(new:goog.proto2.Message)} messageType Constructor for the
<a name="line724"></a> *     message type to which this metadata applies.
<a name="line725"></a> * @param {Object} metadataObj The object containing the metadata.
<a name="line726"></a> * @return {!goog.proto2.Descriptor} The new descriptor.
<a name="line727"></a> * @private
<a name="line728"></a> */
<a name="line729"></a>goog.proto2.Message.createDescriptor_ = function(messageType, metadataObj) {
<a name="line730"></a>  var fields = [];
<a name="line731"></a>  var descriptorInfo = metadataObj[0];
<a name="line732"></a>
<a name="line733"></a>  for (var key in metadataObj) {
<a name="line734"></a>    if (key != 0) {
<a name="line735"></a>      // Create the field descriptor.
<a name="line736"></a>      fields.push(
<a name="line737"></a>          new goog.proto2.FieldDescriptor(messageType, key, metadataObj[key]));
<a name="line738"></a>    }
<a name="line739"></a>  }
<a name="line740"></a>
<a name="line741"></a>  return new goog.proto2.Descriptor(messageType, descriptorInfo, fields);
<a name="line742"></a>};
<a name="line743"></a>
<a name="line744"></a>
<a name="line745"></a>/**
<a name="line746"></a> * Sets the metadata that represents the definition of this message.
<a name="line747"></a> *
<a name="line748"></a> * GENERATED CODE USE ONLY. Called when constructing message classes.
<a name="line749"></a> *
<a name="line750"></a> * @param {!Function} messageType Constructor for the
<a name="line751"></a> *     message type to which this metadata applies.
<a name="line752"></a> * @param {Object} metadataObj The object containing the metadata.
<a name="line753"></a> */
<a name="line754"></a>goog.proto2.Message.set$Metadata = function(messageType, metadataObj) {
<a name="line755"></a>  // NOTE(nicksantos): JSCompiler&#39;s type-based optimizations really do not
<a name="line756"></a>  // like indirectly defined methods (both prototype methods and
<a name="line757"></a>  // static methods). This is very fragile in compiled code. I think it only
<a name="line758"></a>  // really works by accident, and is highly likely to break in the future.
<a name="line759"></a>  messageType.descriptorObj_ = metadataObj;
<a name="line760"></a>  messageType.getDescriptor = function() {
<a name="line761"></a>    // The descriptor is created lazily when we instantiate a new instance.
<a name="line762"></a>    return messageType.descriptor_ ||
<a name="line763"></a>        (new messageType()).getDescriptor();
<a name="line764"></a>  };
<a name="line765"></a>};
</pre>


</body>
</html>
